Index: trunk/source/geometry/solids/Boolean/src/G4UnionSolid.cc
===================================================================
--- trunk/source/geometry/solids/Boolean/src/G4UnionSolid.cc	(revision 1227)
+++ trunk/source/geometry/solids/Boolean/src/G4UnionSolid.cc	(revision 1228)
@@ -26,5 +26,5 @@
 //
 // $Id: G4UnionSolid.cc,v 1.35 2007/10/23 14:42:31 grichine Exp $
-// GEANT4 tag $Name: geant4-09-02-ref-02 $
+// GEANT4 tag $Name: geant4-09-03 $
 //
 // Implementation of methods for the class G4IntersectionSolid
Index: trunk/source/geometry/solids/CSG/History
===================================================================
--- trunk/source/geometry/solids/CSG/History	(revision 1227)
+++ trunk/source/geometry/solids/CSG/History	(revision 1228)
@@ -1,3 +1,3 @@
-$Id: History,v 1.109 2008/11/21 09:50:20 gcosmo Exp $
+$Id: History,v 1.119 2009/11/30 10:20:53 gcosmo Exp $
 -------------------------------------------------------------------
 
@@ -17,4 +17,55 @@
      * Reverse chronological order (last date on top), please *
      ----------------------------------------------------------
+
+Nov 30, 2009  V.Grichine                 geom-csg-V09-02-08
+- G4Orb: moved debug warning in DistanceToIn(p,v) within G4CSGDEBUG flag.
+
+Nov 26, 2009  T.Nikitina                 geom-csg-V09-02-07
+- G4Torus: fix in SolveNumericJT() in order to take in account the difference
+  in the value of theta for different intervals, [0:pi] or [-pi:0], and for
+  SPhi in [0:twopi] or [-twopi:0]. Addresses problem report #1086.
+
+Nov 12, 2009  T.Nikitina                 geom-csg-V09-02-06
+- G4Cons: fix to DistanceToIn(p,v), added a check on the direction in case 
+  of point on surface. Fixes a problem of stuck tracks observed in CMS, due
+  to wrong reply from the solid for points on the inner radius surface base
+  with direction along the imaginary extension of the cone.
+- Added test case to internal test testG4Cons2.
+
+Aug 07, 2009  T.Nikitina                 geom-csg-V09-02-05
+- G4Sphere: fix for the calculation of the normal in DistanceToOut()
+  to avoid cases of division by zero in specific configurations.
+  Addresses problem report #977.
+
+Jun 30, 2009  T.Nikitina                 geom-csg-V09-02-04
+- Introduced to DistanceToIn(p,v) splitting of the distance for point very far
+  from intersection area and big difference between solid dimensions and
+  distance to it; resolves issue observed on 64 bits problem. Affected solids:
+  G4Tubs, G4Cons, G4Sphere, G4Orb. Addresses problem report #1022.
+- Fixed rare cases of NaN on G4Sphere.
+
+Jun 09, 2009  G.Cosmo                    geom-csg-V09-02-03
+- Fixed case of non-initialised start-Phi value in G4Tubs and G4Cons,
+  problem introduced following modifications in tag "geom-csg-V09-02-00".
+
+May 14, 2009  T.Nikitina                 geom-csg-V09-02-02
+- G4Sphere: initialise flags for full sphere in constructor.
+
+May 14, 2009  T.Nikitina                 geom-csg-V09-02-01
+- G4Sphere: correction di DistanceToOut(p,v, ...) for phi sections for
+  rays passing though zero.
+- More minor refiniments to G4Sphere following review.
+
+May 08, 2009  G.Cosmo                    geom-csg-V09-02-00
+- G4Sphere: implemented speed improvements and corrections from joint
+  code review of G4Sphere class. Cached computation for half-tolerances
+  and use of Boolean flag for identifying if full-sphere, shell or section.
+  Implemented caching of trigonometric values, now directly computed inside
+  modifiers for Phi and Theta angles as required for parametrised cases.
+  Rationalised usage of relative radial tolerances.
+- G4Tubs, G4Cons: rationalised usage of modifiers for Phi angles and
+  simplified constructors.
+- Added new test case for relatively big spheres in unit tests testG4Orb
+  and testG4Sphere, based on problem report #1046.
 
 Nov 21, 2008  G.Cosmo                    geom-csg-V09-01-08
Index: trunk/source/geometry/solids/CSG/include/G4Box.hh
===================================================================
--- trunk/source/geometry/solids/CSG/include/G4Box.hh	(revision 1227)
+++ trunk/source/geometry/solids/CSG/include/G4Box.hh	(revision 1228)
@@ -26,5 +26,5 @@
 //
 // $Id: G4Box.hh,v 1.17 2006/10/19 15:33:37 gcosmo Exp $
-// GEANT4 tag $Name: geant4-09-02-ref-02 $
+// GEANT4 tag $Name: geant4-09-03 $
 //
 // --------------------------------------------------------------------
Index: trunk/source/geometry/solids/CSG/include/G4Box.icc
===================================================================
--- trunk/source/geometry/solids/CSG/include/G4Box.icc	(revision 1227)
+++ trunk/source/geometry/solids/CSG/include/G4Box.icc	(revision 1228)
@@ -26,5 +26,5 @@
 //
 // $Id: G4Box.icc,v 1.6 2006/10/19 15:33:37 gcosmo Exp $
-// GEANT4 tag $Name: geant4-09-02-ref-02 $
+// GEANT4 tag $Name: geant4-09-03 $
 //
 // --------------------------------------------------------------------
Index: trunk/source/geometry/solids/CSG/include/G4CSGSolid.hh
===================================================================
--- trunk/source/geometry/solids/CSG/include/G4CSGSolid.hh	(revision 1227)
+++ trunk/source/geometry/solids/CSG/include/G4CSGSolid.hh	(revision 1228)
@@ -26,5 +26,5 @@
 //
 // $Id: G4CSGSolid.hh,v 1.12 2006/10/19 15:33:37 gcosmo Exp $
-// GEANT4 tag $Name: geant4-09-02-ref-02 $
+// GEANT4 tag $Name: geant4-09-03 $
 //
 //  
Index: trunk/source/geometry/solids/CSG/include/G4Cons.hh
===================================================================
--- trunk/source/geometry/solids/CSG/include/G4Cons.hh	(revision 1227)
+++ trunk/source/geometry/solids/CSG/include/G4Cons.hh	(revision 1228)
@@ -25,6 +25,6 @@
 //
 //
-// $Id: G4Cons.hh,v 1.21 2008/11/06 11:04:00 gcosmo Exp $
-// GEANT4 tag $Name: geant4-09-02-ref-02 $
+// $Id: G4Cons.hh,v 1.22 2009/03/31 09:56:24 gcosmo Exp $
+// GEANT4 tag $Name: geant4-09-03 $
 //
 //
@@ -80,47 +80,48 @@
                  G4double pDz,
                  G4double pSPhi, G4double pDPhi);
-         
-    virtual ~G4Cons() ;
+      //
+      // Constructs a cone with the given name and dimensions
+
+   ~G4Cons() ;
+      //
+      // Destructor
 
     // Accessors
 
-    inline G4double    GetInnerRadiusMinusZ() const;
-    inline G4double    GetOuterRadiusMinusZ() const;
-    inline G4double    GetInnerRadiusPlusZ()  const;
-    inline G4double    GetOuterRadiusPlusZ()  const;
-  
-    inline G4double    GetZHalfLength()       const;
-  
-    inline G4double    GetStartPhiAngle () const;
-    inline G4double    GetDeltaPhiAngle () const;
+    inline G4double GetInnerRadiusMinusZ() const;
+    inline G4double GetOuterRadiusMinusZ() const;
+    inline G4double GetInnerRadiusPlusZ()  const;
+    inline G4double GetOuterRadiusPlusZ()  const;
+    inline G4double GetZHalfLength()       const;
+    inline G4double GetStartPhiAngle()     const;
+    inline G4double GetDeltaPhiAngle()     const;
   
     // Modifiers
 
-    inline void    SetInnerRadiusMinusZ( G4double Rmin1 );
-    inline void    SetOuterRadiusMinusZ( G4double Rmax1 );
-    inline void    SetInnerRadiusPlusZ ( G4double Rmin2 );
-    inline void    SetOuterRadiusPlusZ ( G4double Rmax2 );
-         
-    inline void    SetZHalfLength      ( G4double newDz );
-    inline void    SetStartPhiAngle    ( G4double newSPhi);
-    inline void    SetDeltaPhiAngle    ( G4double newDPhi);
+    inline void SetInnerRadiusMinusZ (G4double Rmin1 );
+    inline void SetOuterRadiusMinusZ (G4double Rmax1 );
+    inline void SetInnerRadiusPlusZ  (G4double Rmin2 );
+    inline void SetOuterRadiusPlusZ  (G4double Rmax2 );
+    inline void SetZHalfLength       (G4double newDz );
+    inline void SetStartPhiAngle     (G4double newSPhi, G4bool trig=true);
+    inline void SetDeltaPhiAngle     (G4double newDPhi);
 
     // Other methods for solid
 
-    inline G4double    GetCubicVolume();
-    inline G4double    GetSurfaceArea();
-
-    void ComputeDimensions(G4VPVParameterisation* p,
-                           const G4int n,
-                           const G4VPhysicalVolume* pRep);
-
-    G4bool CalculateExtent(const EAxis pAxis,
-                           const G4VoxelLimits& pVoxelLimit,
-                           const G4AffineTransform& pTransform,
-                                 G4double& pmin, G4double& pmax) const;         
-
-    EInside Inside(const G4ThreeVector& p) const;
-
-    G4ThreeVector SurfaceNormal(const G4ThreeVector& p) const;
+    inline G4double GetCubicVolume();
+    inline G4double GetSurfaceArea();
+
+    void ComputeDimensions(       G4VPVParameterisation* p,
+                            const G4int n,
+                            const G4VPhysicalVolume* pRep );
+
+    G4bool CalculateExtent( const EAxis pAxis,
+                            const G4VoxelLimits& pVoxelLimit,
+                            const G4AffineTransform& pTransform,
+                                  G4double& pmin, G4double& pmax ) const;         
+
+    EInside Inside( const G4ThreeVector& p ) const;
+
+    G4ThreeVector SurfaceNormal( const G4ThreeVector& p ) const;
 
     G4double DistanceToIn (const G4ThreeVector& p,
@@ -134,5 +135,5 @@
     G4double DistanceToOut(const G4ThreeVector& p) const;
 
-    G4GeometryType  GetEntityType() const;
+    G4GeometryType GetEntityType() const;
         
     G4ThreeVector GetPointOnSurface() const; 
@@ -160,45 +161,49 @@
     inline G4double    GetRmin2() const;
     inline G4double    GetRmax2() const;
-  
     inline G4double    GetDz()    const;
-  
     inline G4double    GetSPhi() const;
     inline G4double    GetDPhi() const;
 
-  protected:
+  private:
  
     G4ThreeVectorList*
     CreateRotatedVertices(const G4AffineTransform& pTransform) const;
   
-    G4double fRmin1, fRmin2, fRmax1, fRmax2, fDz, fSPhi, fDPhi;
-    G4bool fPhiFullCone;
+    inline void Initialize();
+      //
+      // Reset relevant values to zero
+
+    inline void CheckSPhiAngle(G4double sPhi);
+    inline void CheckDPhiAngle(G4double dPhi);
+    inline void CheckPhiAngles(G4double sPhi, G4double dPhi);
+      //
+      // Reset relevant flags and angle values
+
+    inline void InitializeTrigonometry();
+      //
+      // Recompute relevant trigonometric values and cache them
+
+    G4ThreeVector ApproxSurfaceNormal(const G4ThreeVector& p) const;
+      //
+      // Algorithm for SurfaceNormal() following the original
+      // specification for points not on the surface
+
+  private:
 
     // Used by distanceToOut
-  
+    //
     enum ESide {kNull,kRMin,kRMax,kSPhi,kEPhi,kPZ,kMZ};
   
     // used by normal
-  
+    //
     enum ENorm {kNRMin,kNRMax,kNSPhi,kNEPhi,kNZ};
 
-  private:
-
-    inline void Initialise();
-      // Reset relevant values to zero
-
-    inline void InitializeTrigonometry();
-      //
-      // Recompute relevant trigonometric values and cache them
-
-    G4ThreeVector ApproxSurfaceNormal(const G4ThreeVector& p) const;
-      //
-      // Algorithm for SurfaceNormal() following the original
-      // specification for points not on the surface
-
-  private:
-
     G4double kRadTolerance, kAngTolerance;
       //
       // Radial and angular tolerances
+
+    G4double fRmin1, fRmin2, fRmax1, fRmax2, fDz, fSPhi, fDPhi;
+      //
+      // Radial and angular dimensions
 
     G4double sinCPhi, cosCPhi, cosHDPhiOT, cosHDPhiIT,
@@ -206,4 +211,8 @@
       //
       // Cached trigonometric values
+
+    G4bool fPhiFullCone;
+      //
+      // Flag for identification of section or full cone
 };
 
Index: trunk/source/geometry/solids/CSG/include/G4Cons.icc
===================================================================
--- trunk/source/geometry/solids/CSG/include/G4Cons.icc	(revision 1227)
+++ trunk/source/geometry/solids/CSG/include/G4Cons.icc	(revision 1228)
@@ -25,6 +25,6 @@
 //
 //
-// $Id: G4Cons.icc,v 1.8 2008/11/06 10:55:40 gcosmo Exp $
-// GEANT4 tag $Name: geant4-09-02-ref-02 $
+// $Id: G4Cons.icc,v 1.11 2009/06/09 16:08:23 gcosmo Exp $
+// GEANT4 tag $Name: geant4-09-03 $
 //
 // --------------------------------------------------------------------
@@ -37,8 +37,50 @@
 
 inline
-void G4Cons::Initialise()
-{
-  fCubicVolume= 0.;
-  fSurfaceArea= 0.;
+G4double G4Cons::GetInnerRadiusMinusZ() const
+{
+  return fRmin1 ;
+}
+
+inline
+G4double G4Cons::GetOuterRadiusMinusZ() const
+{
+  return fRmax1 ;
+}
+
+inline
+G4double G4Cons::GetInnerRadiusPlusZ() const
+{
+  return fRmin2 ;
+}
+
+inline
+G4double G4Cons::GetOuterRadiusPlusZ() const
+{
+  return fRmax2 ;
+}
+
+inline
+G4double G4Cons::GetZHalfLength() const
+{
+  return fDz ;
+}
+
+inline  
+G4double G4Cons::GetStartPhiAngle() const
+{
+  return fSPhi ;
+}
+
+inline
+G4double G4Cons::GetDeltaPhiAngle() const
+{
+  return fDPhi;
+}
+
+inline
+void G4Cons::Initialize()
+{
+  fCubicVolume = 0.;
+  fSurfaceArea = 0.;
   fpPolyhedron = 0;
 }
@@ -61,44 +103,53 @@
 }
 
-inline
-G4double G4Cons::GetInnerRadiusMinusZ() const
-{
-  return fRmin1 ;
-}
-
-inline
-G4double G4Cons::GetOuterRadiusMinusZ() const
-{
-  return fRmax1 ;
-}
-
-inline
-G4double G4Cons::GetInnerRadiusPlusZ() const
-{
-  return fRmin2 ;
-}
-
-inline
-G4double G4Cons::GetOuterRadiusPlusZ() const
-{
-  return fRmax2 ;
-}
-
-inline
-G4double G4Cons::GetZHalfLength() const
-{
-  return fDz ;
-}
-
-inline  
-G4double G4Cons::GetStartPhiAngle() const
-{
-  return fSPhi ;
-}
-
-inline
-G4double G4Cons::GetDeltaPhiAngle() const
-{
-  return fDPhi;
+inline void G4Cons::CheckSPhiAngle(G4double sPhi)
+{
+  // Ensure fSphi in 0-2PI or -2PI-0 range if shape crosses 0
+
+  if ( sPhi < 0 )
+  {
+    fSPhi = twopi - std::fmod(std::fabs(sPhi),twopi);
+  }
+  else
+  {
+    fSPhi = std::fmod(sPhi,twopi) ;
+  }
+  if ( fSPhi+fDPhi > twopi )
+  {
+    fSPhi -= twopi ;
+  }
+}
+
+inline void G4Cons::CheckDPhiAngle(G4double dPhi)
+{
+  fPhiFullCone = true;
+  if ( dPhi >= twopi-kAngTolerance*0.5 )
+  {
+    fDPhi=twopi;
+    fSPhi=0;
+  }
+  else
+  {
+    fPhiFullCone = false;
+    if ( dPhi > 0 )
+    {
+      fDPhi = dPhi;
+    }
+    else
+    {
+      G4cerr << "ERROR - G4Cons()::CheckDPhiAngle()" << G4endl
+             << "        Negative or zero delta-Phi (" << dPhi << ") in solid: "
+             << GetName() << G4endl;
+      G4Exception("G4Cons::CheckDPhiAngle()", "InvalidSetup",
+                  FatalException, "Invalid dphi.");
+    }
+  }
+}
+
+inline void G4Cons::CheckPhiAngles(G4double sPhi, G4double dPhi)
+{
+  CheckDPhiAngle(dPhi);
+  if ( (fDPhi<twopi) && (sPhi) ) { CheckSPhiAngle(sPhi); }
+  InitializeTrigonometry();
 }
 
@@ -107,5 +158,5 @@
 {
   fRmin1= Rmin1 ;
-  Initialise();
+  Initialize();
 }
 
@@ -114,5 +165,5 @@
 {
   fRmax1= Rmax1 ;
-  Initialise();
+  Initialize();
 }
 
@@ -121,5 +172,5 @@
 {
   fRmin2= Rmin2 ;
-  Initialise();
+  Initialize();
 }
 
@@ -128,5 +179,5 @@
 {
   fRmax2= Rmax2 ;
-  Initialise();
+  Initialize();
 }
 
@@ -135,35 +186,23 @@
 {
   fDz= newDz ;
-  Initialise();
-}
-
-inline
-void G4Cons::SetStartPhiAngle ( G4double newSPhi )
-{
-  fSPhi= newSPhi;
-  Initialise();
-  InitializeTrigonometry();
+  Initialize();
+}
+
+inline
+void G4Cons::SetStartPhiAngle ( G4double newSPhi, G4bool compute )
+{
+  // Flag 'compute' can be used to explicitely avoid recomputation of
+  // trigonometry in case SetDeltaPhiAngle() is invoked afterwards
+
+  CheckSPhiAngle(newSPhi);
+  fPhiFullCone = false;
+  if (compute)  { InitializeTrigonometry(); }
+  Initialize();
 }
 
 void G4Cons::SetDeltaPhiAngle ( G4double newDPhi )
 {
-  if ( newDPhi >= twopi-kAngTolerance*0.5 )
-  {
-    fPhiFullCone = true;
-  }
-  else if ( newDPhi > 0 )
-  {
-    fPhiFullCone = false;
-  }
-  else
-  {
-     G4cerr << "ERROR - G4Cons()::SetDeltaPhiAngle() : " << GetName() << G4endl
-            << "        Negative delta-Phi ! - " << newDPhi << G4endl;
-     G4Exception("G4Cons::SetDeltaPhiAngle()", "InvalidSetup",
-                  FatalException, "Invalid dphi.");
-  }
-  fDPhi=  newDPhi;
-  Initialise();
-  InitializeTrigonometry();
+  CheckPhiAngles(fSPhi, newDPhi);
+  Initialize();
 }
 
Index: trunk/source/geometry/solids/CSG/include/G4Orb.hh
===================================================================
--- trunk/source/geometry/solids/CSG/include/G4Orb.hh	(revision 1227)
+++ trunk/source/geometry/solids/CSG/include/G4Orb.hh	(revision 1228)
@@ -26,5 +26,5 @@
 //
 // $Id: G4Orb.hh,v 1.11 2006/10/19 15:33:37 gcosmo Exp $
-// GEANT4 tag $Name: geant4-09-02-ref-02 $
+// GEANT4 tag $Name: geant4-09-03 $
 //
 //
Index: trunk/source/geometry/solids/CSG/include/G4Orb.icc
===================================================================
--- trunk/source/geometry/solids/CSG/include/G4Orb.icc	(revision 1227)
+++ trunk/source/geometry/solids/CSG/include/G4Orb.icc	(revision 1228)
@@ -26,5 +26,5 @@
 //
 // $Id: G4Orb.icc,v 1.5 2006/10/19 15:33:37 gcosmo Exp $
-// GEANT4 tag $Name: geant4-09-02-ref-02 $
+// GEANT4 tag $Name: geant4-09-03 $
 //
 // --------------------------------------------------------------------
Index: trunk/source/geometry/solids/CSG/include/G4Para.hh
===================================================================
--- trunk/source/geometry/solids/CSG/include/G4Para.hh	(revision 1227)
+++ trunk/source/geometry/solids/CSG/include/G4Para.hh	(revision 1228)
@@ -26,5 +26,5 @@
 //
 // $Id: G4Para.hh,v 1.18 2006/10/19 15:33:37 gcosmo Exp $
-// GEANT4 tag $Name: geant4-09-02-ref-02 $
+// GEANT4 tag $Name: geant4-09-03 $
 //
 //
Index: trunk/source/geometry/solids/CSG/include/G4Para.icc
===================================================================
--- trunk/source/geometry/solids/CSG/include/G4Para.icc	(revision 1227)
+++ trunk/source/geometry/solids/CSG/include/G4Para.icc	(revision 1228)
@@ -26,5 +26,5 @@
 //
 // $Id: G4Para.icc,v 1.7 2006/10/19 15:33:37 gcosmo Exp $
-// GEANT4 tag $Name: geant4-09-02-ref-02 $
+// GEANT4 tag $Name: geant4-09-03 $
 //
 // --------------------------------------------------------------------
Index: trunk/source/geometry/solids/CSG/include/G4Sphere.hh
===================================================================
--- trunk/source/geometry/solids/CSG/include/G4Sphere.hh	(revision 1227)
+++ trunk/source/geometry/solids/CSG/include/G4Sphere.hh	(revision 1228)
@@ -25,6 +25,6 @@
 //
 //
-// $Id: G4Sphere.hh,v 1.21 2008/11/21 09:50:05 gcosmo Exp $
-// GEANT4 tag $Name: geant4-09-02-ref-02 $
+// $Id: G4Sphere.hh,v 1.24 2009/03/31 07:51:49 gcosmo Exp $
+// GEANT4 tag $Name: geant4-09-03 $
 //
 //
@@ -36,5 +36,5 @@
 // Class description:
 //
-//   A G4Sphere is, in the general case, section of a spherical shell,
+//   A G4Sphere is, in the general case, a section of a spherical shell,
 //   between specified phi and theta angles
 //
@@ -83,7 +83,12 @@
                    G4double pSPhi, G4double pDPhi,
                    G4double pSTheta, G4double pDTheta);
+      //
+      // Constructs a sphere or sphere shell section
+      // with the given name and dimensions
        
-    virtual ~G4Sphere() ;
-    
+   ~G4Sphere();
+      //
+      // Destructor
+
     // Accessors
        
@@ -99,5 +104,5 @@
     inline void SetInnerRadius    (G4double newRMin);
     inline void SetOuterRadius    (G4double newRmax);
-    inline void SetStartPhiAngle  (G4double newSphi);
+    inline void SetStartPhiAngle  (G4double newSphi, G4bool trig=true);
     inline void SetDeltaPhiAngle  (G4double newDphi);
     inline void SetStartThetaAngle(G4double newSTheta);
@@ -107,5 +112,5 @@
 
     inline G4double GetCubicVolume();
-    inline G4double GetSurfaceArea();
+    G4double GetSurfaceArea();
 
     void ComputeDimensions(      G4VPVParameterisation* p,
@@ -142,4 +147,5 @@
 
     // Visualisation functions
+
     G4VisExtent   GetExtent          () const;    
     void          DescribeYourselfTo(G4VGraphicsScene& scene) const;
@@ -150,4 +156,5 @@
    
     G4Sphere(__void__&);
+      //
       // Fake default constructor for usage restricted to direct object
       // persistency for clients requiring preallocation of memory for
@@ -165,32 +172,65 @@
     inline void SetInsideRadius(G4double newRmin);
 
-  protected:
+  private:
  
     G4ThreeVectorList*
     CreateRotatedVertices(const G4AffineTransform& pTransform,
                                 G4int& noPolygonVertices) const;
-  
+      //
+      // Creates the List of transformed vertices in the format required
+      // for G4VSolid:: ClipCrossSection and ClipBetweenSections
+
+    inline void Initialize();
+      //
+      // Reset relevant values to zero
+
+    inline void CheckThetaAngles(G4double sTheta, G4double dTheta);
+    inline void CheckSPhiAngle(G4double sPhi);
+    inline void CheckDPhiAngle(G4double dPhi);
+    inline void CheckPhiAngles(G4double sPhi, G4double dPhi);
+      //
+      // Reset relevant flags and angle values
+
+    inline void InitializePhiTrigonometry();
+    inline void InitializeThetaTrigonometry();
+      //
+      // Recompute relevant trigonometric values and cache them
+
+    G4ThreeVector ApproxSurfaceNormal( const G4ThreeVector& p) const;
+      //
+      // Algorithm for SurfaceNormal() following the original
+      // specification for points not on the surface
+
+  private:
+
     // Used by distanceToOut
-  
+    //
     enum ESide {kNull,kRMin,kRMax,kSPhi,kEPhi,kSTheta,kETheta};
   
     // used by normal
-  
+    //
     enum ENorm {kNRMin,kNRMax,kNSPhi,kNEPhi,kNSTheta,kNETheta};
 
-  private:
-
-    G4ThreeVector ApproxSurfaceNormal( const G4ThreeVector& p) const;
-      // Algorithm for SurfaceNormal() following the original
-      // specification for points not on the surface
-
-  private:
-
-    G4double kAngTolerance, kRadTolerance;
-
-    G4double fRmin,fRmax,
-             fSPhi,fDPhi,
-             fSTheta,fDTheta;
-    G4double fEpsilon;
+    G4double fEpsilon, fRminTolerance, fRmaxTolerance, kAngTolerance;
+      //
+      // Radial and angular tolerances
+
+    G4double fRmin, fRmax, fSPhi, fDPhi, fSTheta, fDTheta;
+      //
+      // Radial and angular dimensions
+
+    G4double sinCPhi, cosCPhi, cosHDPhiOT, cosHDPhiIT,
+             sinSPhi, cosSPhi, sinEPhi, cosEPhi, hDPhi, cPhi, ePhi;
+      //
+      // Cached trigonometric values for Phi angle
+
+    G4double sinSTheta, cosSTheta, sinETheta, cosETheta,
+             tanSTheta, tanSTheta2, tanETheta, tanETheta2, eTheta;
+      //
+      // Cached trigonometric values for Theta angle
+
+    G4bool fFullPhiSphere, fFullThetaSphere, fFullSphere;
+      //
+      // Flags for identification of section, shell or full sphere
 };
 
Index: trunk/source/geometry/solids/CSG/include/G4Sphere.icc
===================================================================
--- trunk/source/geometry/solids/CSG/include/G4Sphere.icc	(revision 1227)
+++ trunk/source/geometry/solids/CSG/include/G4Sphere.icc	(revision 1228)
@@ -25,6 +25,6 @@
 //
 //
-// $Id: G4Sphere.icc,v 1.8 2008/11/21 09:50:05 gcosmo Exp $
-// GEANT4 tag $Name: geant4-09-02-ref-02 $
+// $Id: G4Sphere.icc,v 1.11 2009/05/13 11:23:00 gcosmo Exp $
+// GEANT4 tag $Name: geant4-09-03 $
 //
 // --------------------------------------------------------------------
@@ -77,11 +77,144 @@
 }
 
+inline 
+void G4Sphere::Initialize()
+{
+  fCubicVolume = 0.;
+  fSurfaceArea = 0.;
+  fpPolyhedron = 0;
+}
+
+inline
+void G4Sphere::InitializePhiTrigonometry()
+{
+  hDPhi = 0.5*fDPhi;                       // half delta phi
+  cPhi  = fSPhi + hDPhi; 
+  ePhi  = fSPhi + fDPhi;
+
+  sinCPhi    = std::sin(cPhi);
+  cosCPhi    = std::cos(cPhi);
+  cosHDPhiIT = std::cos(hDPhi - 0.5*kAngTolerance); // inner/outer tol half dphi
+  cosHDPhiOT = std::cos(hDPhi + 0.5*kAngTolerance);
+  sinSPhi = std::sin(fSPhi);
+  cosSPhi = std::cos(fSPhi);
+  sinEPhi = std::sin(ePhi);
+  cosEPhi = std::cos(ePhi);
+}
+
+inline
+void G4Sphere::InitializeThetaTrigonometry()
+{
+  eTheta  = fSTheta + fDTheta;
+
+  sinSTheta = std::sin(fSTheta);
+  cosSTheta = std::cos(fSTheta);
+  sinETheta = std::sin(eTheta);
+  cosETheta = std::cos(eTheta);
+
+  tanSTheta  = std::tan(fSTheta);
+  tanSTheta2 = tanSTheta*tanSTheta;
+  tanETheta  = std::tan(eTheta);
+  tanETheta2 = tanETheta*tanETheta;
+}
+
+inline
+void G4Sphere::CheckThetaAngles(G4double sTheta, G4double dTheta)
+{
+  if ( (sTheta<0) || (sTheta>pi) )
+  {
+    G4cerr << "ERROR - G4Sphere()::CheckThetaAngles()" << G4endl
+           << "        Invalid starting Theta angle for solid: " << GetName()
+           << G4endl;
+    G4Exception("G4Sphere::CheckThetaAngles()", "InvalidSetup",
+                FatalException, "sTheta outside 0-PI range.");
+  }
+  else
+  {
+    fSTheta=sTheta;
+  }
+  if ( dTheta+sTheta >= pi )
+  {
+    fDTheta=pi-sTheta;
+  }
+  else if ( dTheta > 0 )
+  {
+    fDTheta=dTheta;
+  }
+  else
+  {
+    G4cerr << "ERROR - G4Sphere()::CheckThetaAngles(): " << G4endl
+           << "        Negative delta-Theta (" << dTheta << "), for solid: "
+           << GetName() << G4endl;
+    G4Exception("G4Sphere::CheckThetaAngles()", "InvalidSetup",
+                FatalException, "Invalid dTheta.");
+  }
+  if ( fDTheta-fSTheta < pi ) { fFullThetaSphere = false; }
+  else                        { fFullThetaSphere = true ; }
+  fFullSphere = fFullPhiSphere && fFullThetaSphere;
+
+  InitializeThetaTrigonometry();
+}
+
+inline
+void G4Sphere::CheckSPhiAngle(G4double sPhi)
+{
+  // Ensure fSphi in 0-2PI or -2PI-0 range if shape crosses 0
+
+  if ( sPhi < 0 )
+  {
+    fSPhi = twopi - std::fmod(std::fabs(sPhi),twopi);
+  }
+  else
+  {
+    fSPhi = std::fmod(sPhi,twopi) ;
+  }
+  if ( fSPhi+fDPhi > twopi )
+  {
+    fSPhi -= twopi ;
+  }
+}
+
+inline
+void G4Sphere::CheckDPhiAngle(G4double dPhi)
+{
+  fFullPhiSphere = true;
+  if ( dPhi >= twopi-kAngTolerance*0.5 )
+  {
+    fDPhi=twopi;
+    fSPhi=0;
+  }
+  else
+  {
+    fFullPhiSphere = false;
+    if ( dPhi > 0 )
+    {
+      fDPhi = dPhi;
+    }
+    else
+    {
+      G4cerr << "ERROR - G4Sphere()::CheckDPhiAngle(): " << GetName() << G4endl
+             << "        Negative delta-Phi ! - "
+             << dPhi << G4endl;
+      G4Exception("G4Sphere::CheckDPhiAngle()", "InvalidSetup",
+                  FatalException, "Invalid dphi.");
+    }
+  }
+}
+
+inline
+void G4Sphere::CheckPhiAngles(G4double sPhi, G4double dPhi)
+{
+  CheckDPhiAngle(dPhi);
+  if (!fFullPhiSphere && sPhi) { CheckSPhiAngle(sPhi); }
+  fFullSphere = fFullPhiSphere && fFullThetaSphere;
+
+  InitializePhiTrigonometry();
+}
+
 inline
 void G4Sphere::SetInsideRadius(G4double newRmin)
 {
   fRmin= newRmin;
-  fCubicVolume= 0.;
-  fSurfaceArea= 0.;
-  fpPolyhedron = 0;
+  Initialize();
 }
 
@@ -90,7 +223,5 @@
 {
   fRmin= newRmin;
-  fCubicVolume= 0.;
-  fSurfaceArea= 0.;
-  fpPolyhedron = 0;
+  Initialize();
 }
 
@@ -99,25 +230,24 @@
 {
   fRmax= newRmax;
-  fCubicVolume= 0.;
-  fSurfaceArea= 0.;
-  fpPolyhedron = 0;
-}
-
-inline
-void G4Sphere::SetStartPhiAngle(G4double newSphi)
-{
-  fSPhi= newSphi;
-  fCubicVolume= 0.;
-  fSurfaceArea= 0.;
-  fpPolyhedron = 0;
-}
-
-inline
-void G4Sphere::SetDeltaPhiAngle(G4double newDphi)
-{
-  fDPhi= newDphi;
-  fCubicVolume= 0.;
-  fSurfaceArea= 0.;
-  fpPolyhedron = 0;
+  Initialize();
+}
+
+inline
+void G4Sphere::SetStartPhiAngle(G4double newSPhi, G4bool compute)
+{
+  // Flag 'compute' can be used to explicitely avoid recomputation of
+  // trigonometry in case SetDeltaPhiAngle() is invoked afterwards
+
+  CheckSPhiAngle(newSPhi);
+  fFullPhiSphere = false;
+  if (compute)  { InitializePhiTrigonometry(); }
+  Initialize();
+}
+
+inline
+void G4Sphere::SetDeltaPhiAngle(G4double newDPhi)
+{
+  CheckPhiAngles(fSPhi, newDPhi);
+  Initialize();
 }
 
@@ -125,8 +255,6 @@
 void G4Sphere::SetStartThetaAngle(G4double newSTheta)
 {
-  fSTheta=newSTheta;
-  fCubicVolume= 0.;
-  fSurfaceArea= 0.;
-  fpPolyhedron = 0;
+  CheckThetaAngles(newSTheta, fDTheta);
+  Initialize();
 }
 
@@ -134,8 +262,6 @@
 void G4Sphere::SetDeltaThetaAngle(G4double newDTheta)
 {
-  fDTheta=newDTheta;
-  fCubicVolume= 0.;
-  fSurfaceArea= 0.;
-  fpPolyhedron = 0;
+  CheckThetaAngles(fSTheta, newDTheta);
+  Initialize();
 }
 
@@ -182,54 +308,6 @@
 {
   if(fCubicVolume != 0.) {;}
-  else   fCubicVolume = fDPhi*(std::cos(fSTheta)-std::cos(fSTheta+fDTheta))*
-                              (fRmax*fRmax*fRmax-fRmin*fRmin*fRmin)/3.; 
+  else { fCubicVolume = fDPhi*(std::cos(fSTheta)-std::cos(fSTheta+fDTheta))*
+                              (fRmax*fRmax*fRmax-fRmin*fRmin*fRmin)/3.; }
   return fCubicVolume;
 }
-
-
-inline
-G4double G4Sphere::GetSurfaceArea()
-{
-  if(fSurfaceArea != 0.) {;}
-  else
-  {   
-    G4double Rsq=fRmax*fRmax;
-    G4double rsq=fRmin*fRmin;
-         
-    fSurfaceArea = fDPhi*(rsq+Rsq)*(std::cos(fSTheta)
-                 - std::cos(fSTheta+fDTheta));
-    if(fDPhi < twopi)
-    {
-      fSurfaceArea = fSurfaceArea + fDTheta*(Rsq-rsq);
-    }
-    if(fSTheta >0)
-    {
-      G4double acos1=std::acos( std::pow(std::sin(fSTheta),2)
-                               *std::cos(fDPhi)
-                               +std::pow(std::cos(fSTheta),2));
-      if(fDPhi>pi)
-      { 
-        fSurfaceArea = fSurfaceArea + 0.5*(Rsq-rsq)*(twopi-acos1);
-      }
-      else
-      {
-        fSurfaceArea = fSurfaceArea + 0.5*(Rsq-rsq)*acos1;
-      }
-    }
-    if(fDTheta+fSTheta < pi)
-    {
-      G4double acos2=std::acos( std::pow(std::sin(fSTheta+fDTheta),2)
-                               *std::cos(fDPhi)
-                               +std::pow(std::cos(fSTheta+fDTheta),2));
-      if(fDPhi>pi)
-      { 
-        fSurfaceArea = fSurfaceArea + 0.5*(Rsq-rsq)*(twopi-acos2);
-      }
-      else
-      {
-        fSurfaceArea = fSurfaceArea + 0.5*(Rsq-rsq)*acos2;
-      }
-    }
-  }
-  return fSurfaceArea;
-}
Index: trunk/source/geometry/solids/CSG/include/G4Torus.hh
===================================================================
--- trunk/source/geometry/solids/CSG/include/G4Torus.hh	(revision 1227)
+++ trunk/source/geometry/solids/CSG/include/G4Torus.hh	(revision 1228)
@@ -26,5 +26,5 @@
 //
 // $Id: G4Torus.hh,v 1.27 2007/05/18 07:38:00 gcosmo Exp $
-// GEANT4 tag $Name: geant4-09-02-ref-02 $
+// GEANT4 tag $Name: geant4-09-03 $
 //
 // 
Index: trunk/source/geometry/solids/CSG/include/G4Torus.icc
===================================================================
--- trunk/source/geometry/solids/CSG/include/G4Torus.icc	(revision 1227)
+++ trunk/source/geometry/solids/CSG/include/G4Torus.icc	(revision 1228)
@@ -26,5 +26,5 @@
 //
 // $Id: G4Torus.icc,v 1.6 2006/10/19 15:33:37 gcosmo Exp $
-// GEANT4 tag $Name: geant4-09-02-ref-02 $
+// GEANT4 tag $Name: geant4-09-03 $
 //
 // --------------------------------------------------------------------
Index: trunk/source/geometry/solids/CSG/include/G4Trap.hh
===================================================================
--- trunk/source/geometry/solids/CSG/include/G4Trap.hh	(revision 1227)
+++ trunk/source/geometry/solids/CSG/include/G4Trap.hh	(revision 1228)
@@ -26,5 +26,5 @@
 //
 // $Id: G4Trap.hh,v 1.17 2006/10/19 15:33:37 gcosmo Exp $
-// GEANT4 tag $Name: geant4-09-02-ref-02 $
+// GEANT4 tag $Name: geant4-09-03 $
 //
 // 
Index: trunk/source/geometry/solids/CSG/include/G4Trap.icc
===================================================================
--- trunk/source/geometry/solids/CSG/include/G4Trap.icc	(revision 1227)
+++ trunk/source/geometry/solids/CSG/include/G4Trap.icc	(revision 1228)
@@ -26,5 +26,5 @@
 //
 // $Id: G4Trap.icc,v 1.8 2006/10/19 15:33:37 gcosmo Exp $
-// GEANT4 tag $Name: geant4-09-02-ref-02 $
+// GEANT4 tag $Name: geant4-09-03 $
 //
 // --------------------------------------------------------------------
Index: trunk/source/geometry/solids/CSG/include/G4Trd.hh
===================================================================
--- trunk/source/geometry/solids/CSG/include/G4Trd.hh	(revision 1227)
+++ trunk/source/geometry/solids/CSG/include/G4Trd.hh	(revision 1228)
@@ -26,5 +26,5 @@
 //
 // $Id: G4Trd.hh,v 1.16 2006/10/19 15:33:37 gcosmo Exp $
-// GEANT4 tag $Name: geant4-09-02-ref-02 $
+// GEANT4 tag $Name: geant4-09-03 $
 //
 // 
